if select(2, UnitClass("player")) ~= "MONK" then
    return
end

local bar = CreateFrame("StatusBar", "DeathNoteBar", UIParent)
local warn = 0
local warning = 1

ignore = {worldboss=0, rareelite=0, elite=0, rare=0, normal=1, trivial=1, minus=1}
notify = {worldboss=0, rareelite=0, elite=0, rare=0, normal=1, trivial=1, minus=1}
outCombatPref = true

SLASH_DEATHKNELL1 = '/deathknell';
SLASH_DEATHKNELLNOT1 = '/deathknellnotify';

function SlashCmdList.DEATHKNELL(msg, editbox)
	if msg == "combat" then
		outCombatPref = not outCombatPref
		if outCombatPref then
			print("Notifying while out of combat ENABLED.")
		else
			print("Notifying while out of combat DISABLED.")
		end
		return
	end

	if msg == "worldboss" or msg == "rareelite" or msg == "elite" or msg == "rare" or msg == "normal" or msg == "trivial" or msg == "minus" then
		ignore[msg] = 1 - ignore[msg]
		if ignore[msg] == 1 then
			print("Bar for "..msg.." is now OFF.")
		else
			print("Bar for "..msg.." is now ON.")
		end
	else
		print("type /deathknell <arg> where <arg> is worldboss, rareelite, elite, rare, normal, trivial or minus to toggle Touch of Death healthbars")
		print("type /deathknellnotify <arg> where <arg> is worldboss, rareelite, elite, rare, normal, trivial or minus to toggle Touch of Death notifications")
		print("type /deathknell combat to toggle if addon only works in combat.")
		print(" ")
		print("Bar status:")

		for k,v in pairs(ignore) do
			local status
			if v==0 then
				status = "ON"
			else
				status = "OFF"
			end
			print(k.." = "..status)
		end

	end
end

function SlashCmdList.DEATHKNELLNOT(msg, editbox)
	if msg == "worldboss" or msg == "rareelite" or msg == "elite" or msg == "rare" or msg == "normal" or msg == "trivial" or msg == "minus" then
		notify[msg] = 1 - notify[msg]
		if notify[msg] == 1 then
			print("Notification for "..msg.." is now OFF.")
		else
			print("Notification for "..msg.." is now ON.")
		end
	else
		print("type /deathknell <arg> where <arg> is worldboss, rareelite, elite, rare, normal, trivial or minus to toggle Touch of Death healthbars")
		print("type /deathknellnotify <arg> where <arg> is worldboss, rareelite, elite, rare, normal, trivial or minus to toggle Touch of Death notifications")
		print(" ")
		print("Notification status:")

		for k,v in pairs(notify) do
			local status
			if v==0 then
				status = "ON"
			else
				status = "OFF"
			end
			print(k.." = "..status)
		end
	end
end

function hp_update()

   if UnitIsFriend("player","target") or UnitIsDead("target") or not combat() then
	bar:Hide()
	return
   else

	local monkHP = UnitHealthMax("player")
	local targetHP = UnitHealthMax("target")
	local targetCurrHP = UnitHealth("target")
	local partySize = max(1,GetNumGroupMembers())
	local range = math.max(0, min(partySize*monkHP, targetHP-monkHP))
	local currHP = math.max(0, math.min(range, targetCurrHP-monkHP))

	if (UnitIsPlayer("target") and (UnitIsPVP("target") or UnitIsPVPFreeForAll("target")) ) then

		local pvptargetHP = math.floor(0.9*targetHP)
		currHP = math.floor(math.max(0, targetCurrHP - 0.1*targetHP))
		local text = currHP.."/"..pvptargetHP 

		bar:SetMinMaxValues(0, pvptargetHP)
		bar:SetValue(currHP)
		bar.Text:SetText(text)
		bar:Show()
	else

		if ignoreList() then
			bar:Hide()
		else

			bar:SetMinMaxValues(0, range)
			local text = currHP.."/"..range
			bar:SetValue(currHP)
			bar.Text:SetText(text)
		
				if (targetCurrHP-monkHP) > range then
				bar:Hide()
			else
				bar:Show()
			end
	
		end
	end

	if currHP <= 0 then
		bar:SetBackdropColor(0,0,0,1)
		if warn ==0 and notifyList() and UnitExists("target") then

			local colour
			if warning == 1 then
				colour = "cffff0000"
				warning = 0
			else
				colour = "cff0000ff"
				warning = 1
			end

			RaidNotice_AddMessage(RaidWarningFrame, "\124"..colour.."Touch of Death range reached!\124r", ChatTypeInfo["RAID_WARNING"])
			PlaySound("RaidWarning", "master")
			warn = 1
		end 
	else
		bar:SetBackdropColor(0,0,0,0.6)
		warn = 0
	end
   end
end

function combat()
	if InCombatLockdown() == 1 or outCombatPref then
		return true
	end
	return false
end

function ignoreList()
	local flag = ignore[UnitClassification("target")]

	if flag == 1 then
		return true
	end
	
	return false	
end


function notifyList()

	if (UnitIsPlayer("target") and (UnitIsPVP("target") or UnitIsPVPFreeForAll("target")) ) then
		return true
	end

	local flag = notify[UnitClassification("target")]

	if flag == 1 then
		return false
	end
	
	return true	
end

function createDeathNoteBar()
	bar:SetWidth(118)
	bar:SetHeight(14)
	bar:SetPoint("CENTER")
	bar:SetClampedToScreen(true)
	bar:SetScale(1)
	bar:SetBackdrop({
		bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]],
		tile = true,
		tileSize = 16,
	})
	bar:SetStatusBarTexture([[Interface\TARGETINGFRAME\UI-StatusBar]],"OVERLAY")
	bar:SetOrientation("HORIZONTAL")
	bar:SetStatusBarColor(0,0,0,1)
	bar:SetBackdropColor(0,0,0,0.6)
 	bar:GetStatusBarTexture():SetGradient("HORIZONTAL", 255/255, 153/255, 102/255, 204/255, 51/255, 51/255)
	
	local border = bar:CreateTexture(nil, "BACKGROUND")
	border:SetPoint("CENTER")
	border:SetWidth(bar:GetWidth()+9)
	border:SetHeight(bar:GetHeight()+8)
	border:SetTexture([[Interface\Tooltips\UI-StatusBar-Border]])
	bar.Border = border

	local bartext = bar:CreateFontString(nil, "OVERLAY")
	bar.Text = bartext
	bar.Text:SetFontObject("GameFontHighlightSmall")
	bar.Text:SetPoint("TOP",bar,"TOP",0,-2)
	bar.Text:SetTextColor(1,1,1)
	
	bar:SetMinMaxValues(0,1)
	bar:SetValue(0)
	
  bar:SetMovable();
  bar:RegisterForDrag("LeftButton");

  bar:SetScript("OnDragStart", function(self, button) if IsAltKeyDown() then self:StartMoving() end end);
  bar:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end);
  bar:SetScript("OnEnter", 
  function(self) 
  	GameTooltip:SetOwner(self,"ANCHOR_BOTTOMRIGHT"); 
  	GameTooltip:SetClampedToScreen(true);
  	GameTooltip:ClearLines();
  	GameTooltip:SetText("|TInterface\\Icons\\Ability_Monk_TouchofDeath:16|t DeathKnell", 1, 0.4, 0.4, 1)
  	GameTooltip:Show() 
  end);
  bar:SetScript("OnLeave", function(self) GameTooltip_Hide() end);

  bar:EnableMouse(true)
  bar.locked = nil


	--bar:RegisterEvent("PLAYER_TARGET_CHANGED")
	bar:RegisterUnitEvent("UNIT_HEALTH_FREQUENT", "target")
	bar:SetScript("OnEvent", hp_update)

	bar:Show();  
  
  return bar;
end

--local function SpellSuccess(unitID, spell, rank, lineID, spellID)
--end

local DNbar = createDeathNoteBar()

local DNtarwatch = CreateFrame("Frame")
DNtarwatch:SetScript("OnEvent", function() warn=0 hp_update() end)
DNtarwatch:RegisterEvent("PLAYER_TARGET_CHANGED")


--local DNlogger =  CreateFrame("Frame")
--DNlogger:SetScript("OnEvent", SpellSuccess)
--DNlogger:RegisterUnitEvent("UNIT_SPELLCAST_SUCCEEDED", "player")